<!DOCTYPE html>
<html>
<head>
    <title> CAR DB </title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
</head>
<script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    // CAR_DB: database of cars
    // vID: vehicle identification number
    const gCAR_DB = [
        { make: "Ford", model: "Explorer", year: 2017, color: "white", vID: "AB-10111" },
        { make: "Toyota", model: "Corolla", year: 2018, color: "silver", vID: "DN-23218" },
        { make: "Mazda", model: "Mazda 6", year: 2020, color: "red", vID: "TZ-23212" },
        { make: "Toyota", model: "Fortuna", year: 2016, color: "black", vID: "IN-91925" },
        { make: "Mazda", model: "Mazda 3", year: 2019, color: "silver", vID: "MN-44593" }
    ];

    /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
    

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading() {
        // Code để chạy thử test hàm getCarByIndex()
        var vCarA = getCarByIndex(1); // hàm này trả về một đối tượng
        console.log("Car found by getCarByIndex, index = " + 1);
        console.log(vCarA.make);
        console.log(vCarA.model);
        console.log(vCarA.color);
        
        // Bạn hãy viết code chạy thử test hàm getCarByVID() xuống bên dưới
        var vId = "MN-44593";
        var vCarB = getCarByVID(vId);
        if (vCarB != null) {
            console.log("Car found by getCarByVID, vID = " + vId);
            console.log(vCarB.make);
            console.log(vCarB.model);
            console.log(vCarB.color);
        } else {
            console.log("Car not found by getCarByVID, vID = " + vId);
        }
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // đây là 01 function đã trả lại object car bởi index.
    // bạn hãy tham khảo cách trả lại khi tìm thấy và không tìm thấy
    function getCarByIndex(paramIndexOfCar) {
        //if the input index not in the invalid range (index đưa vào không có trong array gCAR_DB)
        if (paramIndexOfCar < 0 || paramIndexOfCar > gCAR_DB.length - 1) { 
            return null; 
        }
        // nếu có thì return object ở vị trí đó
        return gCAR_DB[paramIndexOfCar];
    }

    // bạn hãy viết function trả lại car 
    // gợi ý:  bạn cần có 1 vòng lặp và tìm ra item đó nếu vID của item bằng input paramCarVID
    // nên nhớ nếu bạn tìm thấy có thể ra khỏi vòng lặp ngay, vì vID là duy nhất 
    // (gơi ý tìm kiếm "while loop javascript")
    function getCarByVID(paramCarVID) {
        var vIndex = 0;//chỉ số phần tử duyệt
        var vCarObj = null;//lưu kết quả trả về
        var vFound = false;//kiểm tra đã tìm thấy hay chưa
        //Thuật toán: nếu chưa tìm thấy và chỉ số < length thì cứ duyệt tiếp đến khi nào tìm thấy
        while (vFound == false && vIndex < gCAR_DB.length) {
            if (gCAR_DB[vIndex].vID == paramCarVID) {//tìm thấy
                vCarObj = gCAR_DB[vIndex];//gán kết quả = car tại vị trí duyệt;
                vFound = true;
            } else {//chưa tìm thấy => tăng chỉ số để duyệt tiếp
                vIndex++;
            }
        }

        return vCarObj;
    }
</script>

<body onload="onPageLoading()" class="bg bg-transparent">
    <div class="jumbotron">
        <h1></h1> Test Page for Devcamp Javascrip Tasks </h1>
        <p> Press F5 to run code. Don't forget to Save your code before running. (Ctrl+S). </p>
    </div>
</body>

</html>